package eu.mhsl.craftattack.spawn.appliances.tooling.adminChat;

import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.event.ClickEvent;
import net.kyori.adventure.text.format.NamedTextColor;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class AdminChat extends Appliance {
    public void sendMessage(Player sender, String message) {
        Component privatePrefix = Component
            .text("[Admin] ", NamedTextColor.LIGHT_PURPLE)
            .clickEvent(ClickEvent.suggestCommand(AdminChatCommand.commandName));

        Bukkit.getOnlinePlayers().stream()
            .filter(player -> player.hasPermission("admin"))
            .forEach(player -> {
                Component formattedMessage = Component.text()
                    .append(privatePrefix)
                    .append(sender.displayName())
                    .append(Component.text(" > ", NamedTextColor.DARK_GRAY))
                    .append(Component.text(message))
                    .build();
                player.sendMessage(formattedMessage);
            });
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(new AdminChatCommand());
    }
}
