package eu.mhsl.craftattack.spawn.appliances.tooling.endPrevent;

import eu.mhsl.craftattack.spawn.appliance.Appliance;
import eu.mhsl.craftattack.spawn.appliance.ApplianceCommand;
import eu.mhsl.craftattack.spawn.config.Configuration;
import org.bukkit.event.Listener;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public class EndPrevent extends Appliance {
    private final String endDisabledKey = "endDisabled";
    private boolean endDisabled;

    public EndPrevent() {
        super("endPrevent");
        this.endDisabled = this.localConfig().getBoolean(this.endDisabledKey);
    }

    public void setEndDisabled(boolean disabled) {
        this.localConfig().set(this.endDisabledKey, disabled);
        Configuration.saveChanges();
        this.endDisabled = disabled;
    }

    public boolean isEndDisabled() {
        return this.endDisabled;
    }

    @Override
    protected @NotNull List<Listener> listeners() {
        return List.of(new PreventEnderEyeUseListener());
    }

    @Override
    protected @NotNull List<ApplianceCommand<?>> commands() {
        return List.of(new EndPreventCommand());
    }
}
