package eu.mhsl.craftattack.spawn.appliances.tooling.maintenance;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.util.text.DisconnectInfo;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.PlayerLoginEvent;

class PreventMaintenanceJoinListener extends ApplianceListener<Maintenance> {
    @EventHandler
    public void onJoin(PlayerLoginEvent event) {
        if(!this.getAppliance().isInMaintenance()) return;
        if(event.getPlayer().hasPermission("bypassMaintainance")) return;

        DisconnectInfo disconnectInfo = new DisconnectInfo(
            "Server für Spieler nicht verfügbar",
            "Zurzeit können nur Admins dem Server beitreten!",
            "Bitte versuche es später erneut.",
            event.getPlayer().getUniqueId()
        );

        event.disallow(PlayerLoginEvent.Result.KICK_OTHER, disconnectInfo.getComponent());
    }
}
